zenilib: Zeni::Renderable Class Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Public Member Functions | List of all members
Zeni::Renderable Class Referenceabstract
Zenilib

A Renderable Interface. More...

`#include <Renderable.h>`

Inherited by Zeni::Quadrilateral< Zeni::Vertex2f_Color >, Zeni::Triangle< Zeni::Vertex3f_Color >, Zeni::Triangle< Zeni::Vertex3f_Texture >, Zeni::Line_Segment< VERTEX >, Zeni::Quadrilateral< VERTEX >, Zeni::Triangle< VERTEX >, Zeni::Vertex2f_Color, Zeni::Vertex2f_Texture, Zeni::Vertex3f_Color, and Zeni::Vertex3f_Texture.

## Public Member Functions

| Renderable ()
| Renderable (const Renderable &rhs)
virtual | ~Renderable ()
void | fax_Material (const Material *const &material)
| Set the Material, giving the Renderable a copy. More...
const Material * | get_Material () const
| Get the Material. More...
void | give_Material (Material *const &material)
| Set the Material, giving the Renderable ownership. More...
virtual bool | is_3d () const =0
| Tell the rendering system if we're using 3D coordinates. More...
void | lend_Material (const Material *const &material)
| Set the Material, giving the Renderable no ownership. More...
Renderable & | operator= (const Renderable &rhs)
virtual void | post_render () const
virtual void | pre_render () const
virtual void | render_to (Video_GL_Fixed &screen) const =0
| Overridden for OpenGL rendering. More...
virtual void | render_to (Video_GL_Shader &screen) const =0
| Overridden for OpenGL rendering. More...
virtual void | render_to (Video_DX9 &screen) const =0
| Overridden for Direct3D9 rendering. More...

## Detailed Description

A Renderable Interface.

This class provides an interface for anything that "knows how to render itself" it all rendering engines supported by zenilib.

Author
  bazald

Contact: bazal.nosp@m.d@ze.nosp@m.nipex.nosp@m..com

Definition at line 47 of file Renderable.h.

## Constructor & Destructor Documentation

Zeni::Renderable::Renderable | ( |  | ) |

inline

Definition at line 28 of file Renderable.hxx.

Zeni::Renderable::~Renderable | ( |  | ) |

virtual

Definition at line 27 of file Renderable.cpp.

Zeni::Renderable::Renderable | ( | const Renderable & | rhs | ) |

inline

Definition at line 34 of file Renderable.hxx.

References fax_Material().

## Member Function Documentation

void Zeni::Renderable::fax_Material | ( | const Material *const & | material | ) |

Set the Material, giving the Renderable a copy.

Definition at line 50 of file Renderable.cpp.

References give_Material().

Referenced by Zeni::Vertex_Buffer::fax_Triangle(), Zeni::Quadrilateral< VERTEX >::get_duplicate_t0(), Zeni::Quadrilateral< VERTEX >::get_duplicate_t1(), operator=(), and Renderable().

const Material * Zeni::Renderable::get_Material | ( |  | ) | const

inline

Get the Material.

Manage Render_Wrappers

Definition at line 47 of file Renderable.hxx.

Referenced by Zeni::Vertex_Buffer::fax_Triangle(), and Zeni::Vertex_Buffer::give_Triangle().

void Zeni::Renderable::give_Material | ( | Material *const & | material | ) |

Set the Material, giving the Renderable ownership.

Definition at line 32 of file Renderable.cpp.

Referenced by fax_Material().

virtual bool Zeni::Renderable::is_3d | ( |  | ) | const

pure virtual

Tell the rendering system if we're using 3D coordinates.

Implemented in Zeni::Vertex2f_Texture, Zeni::Vertex3f_Texture, Zeni::Vertex2f_Color, Zeni::Vertex3f_Color, Zeni::Quadrilateral< VERTEX >, Zeni::Quadrilateral< Zeni::Vertex2f_Color >, Zeni::Triangle< VERTEX >, Zeni::Triangle< Zeni::Vertex3f_Texture >, Zeni::Triangle< Zeni::Vertex3f_Color >, and Zeni::Line_Segment< VERTEX >.

Referenced by Zeni::Video_DX9::render().

void Zeni::Renderable::lend_Material | ( | const Material *const & | material | ) |

Set the Material, giving the Renderable no ownership.

Definition at line 41 of file Renderable.cpp.

Referenced by Zeni::render_image(), and Zeni::Widget_Renderer_Texture::render_to().

Renderable & Zeni::Renderable::operator= | ( | const Renderable & | rhs | ) |

inline

Definition at line 41 of file Renderable.hxx.

References fax_Material().

void Zeni::Renderable::post_render | ( |  | ) | const

virtual

Definition at line 61 of file Renderable.cpp.

References Zeni::get_Video(), and Zeni::Video::unset_Material().

Referenced by Zeni::Video_GL_Fixed::render(), Zeni::Video_GL_Shader::render(), and Zeni::Video_DX9::render().

void Zeni::Renderable::pre_render | ( |  | ) | const

virtual

Definition at line 56 of file Renderable.cpp.

References Zeni::get_Video(), and Zeni::Video::set_Material().

Referenced by Zeni::Video_GL_Fixed::render(), Zeni::Video_GL_Shader::render(), and Zeni::Video_DX9::render().

virtual void Zeni::Renderable::render_to | ( | Video_GL_Fixed & | screen | ) | const

pure virtual

Overridden for OpenGL rendering.

Implemented in Zeni::Vertex2f_Texture, Zeni::Vertex3f_Texture, Zeni::Vertex2f_Color, Zeni::Vertex3f_Color, Zeni::Quadrilateral< VERTEX >, Zeni::Quadrilateral< Zeni::Vertex2f_Color >, Zeni::Triangle< VERTEX >, Zeni::Triangle< Zeni::Vertex3f_Texture >, Zeni::Triangle< Zeni::Vertex3f_Color >, and Zeni::Line_Segment< VERTEX >.

Referenced by Zeni::Video_GL_Fixed::render(), Zeni::Video_GL_Shader::render(), and Zeni::Video_DX9::render().

virtual void Zeni::Renderable::render_to | ( | Video_GL_Shader & | screen | ) | const

pure virtual

Overridden for OpenGL rendering.

Implemented in Zeni::Quadrilateral< VERTEX >, Zeni::Triangle< VERTEX >, Zeni::Quadrilateral< VERTEX >, Zeni::Line_Segment< VERTEX >, Zeni::Triangle< VERTEX >, Zeni::Line_Segment< VERTEX >, Zeni::Quadrilateral< VERTEX >, Zeni::Quadrilateral< VERTEX >, Zeni::Triangle< VERTEX >, Zeni::Vertex2f_Texture, Zeni::Vertex3f_Texture, Zeni::Triangle< VERTEX >, Zeni::Line_Segment< VERTEX >, Zeni::Line_Segment< VERTEX >, Zeni::Vertex2f_Color, Zeni::Vertex3f_Color, Zeni::Quadrilateral< VERTEX >, Zeni::Quadrilateral< Zeni::Vertex2f_Color >, Zeni::Triangle< VERTEX >, Zeni::Triangle< Zeni::Vertex3f_Texture >, Zeni::Triangle< Zeni::Vertex3f_Color >, and Zeni::Line_Segment< VERTEX >.

virtual void Zeni::Renderable::render_to | ( | Video_DX9 & | screen | ) | const

pure virtual

Overridden for Direct3D9 rendering.

Implemented in Zeni::Vertex2f_Texture, Zeni::Vertex3f_Texture, Zeni::Vertex2f_Color, Zeni::Vertex3f_Color, Zeni::Quadrilateral< VERTEX >, Zeni::Quadrilateral< Zeni::Vertex2f_Color >, Zeni::Triangle< VERTEX >, Zeni::Triangle< Zeni::Vertex3f_Texture >, Zeni::Triangle< Zeni::Vertex3f_Color >, and Zeni::Line_Segment< VERTEX >.

The documentation for this class was generated from the following files:

- zenilib/jni/external/zenilib/zeni_graphics/Zeni/Renderable.h
- zenilib/jni/external/zenilib/zeni_graphics/Renderable.cpp
- zenilib/jni/external/zenilib/zeni_graphics/Zeni/Renderable.hxx